#include <stdio.h>
#include <windows.h> 
#include <excpt.h> 

#define OP_NONE           0x00
#define OP_MODRM          0x01
#define OP_DATA_I8        0x02
#define OP_DATA_I16       0x04
#define OP_DATA_I32       0x08
#define OP_DATA_PRE66_67  0x10
#define OP_WORD           0x20
#define OP_REL32          0x40

typedef unsigned int uint;
typedef unsigned char uchar;
typedef unsigned char* Puchar;

int GetSizeOfCode(void *Code, uchar *pOpcode);
int __trace(uchar* _ptr, uint adr);

struct stack_point
{
	uint* opcode;		// ptr to first byte call opcode
	uint* operand;		// ptr to address operand if is
	uint  opcodeSize;	// full opcode size
	uint  operandSize;  // operand size	
	uint* ret;			// ptr to ret address in stack
	uint  stackFrameSize;
};

//   ,     size
// 0x9A - segment call not supported
stack_point* __stack(int* size)
{
	uint* _ebp = 0;

	__asm mov _ebp, esp;

	stack_point* sp = new stack_point[*size];
	int count = 0;

	while(++_ebp)
	{
		uchar* _ptr = (uchar*)*_ebp;
		if ((int)_ptr < 0x1000 || IsBadReadPtr(_ptr - 6, 6)) continue;

		_ptr--;

		int res = 0;

		if		(_ptr[-4] == (uchar)0xE8)									// E8 5b
		{
			res = 1;
		}
		else if (_ptr[-5] == (uchar)0xff &&									// FF | 1001xxxx 6b or
			((_ptr[-4] & 0xF0) == 0x90 || _ptr[-4] == 0x15))				// FF | 15       6b
		{
			res |= 2;
		}


		if (_ptr[-1] == (uchar)0xff &&										// FF | 0001xxxx 2b or
			((*_ptr & 0xF0) == 0x10 || (*_ptr & 0xF0) == 0xD0))				// FF | 1101xxxx 2b
		{
			res |= 4;
		}
		else if (_ptr[-2] == (uchar)0xff && (_ptr[-1] & 0xF0) == 0x50)		// FF | 0101xxxx 3b
		{
			res |= 8;
		}


		if		(res == 0) 
		{
			continue;
		}
		else if (res == 1) // 5b
		{
b5:			sp[count].opcode = (uint*)(_ptr - 4);
			sp[count].opcodeSize = 5;
			sp[count].operand = (uint*)(_ptr - 3);
			sp[count].operandSize = 4;
			sp[count].ret = _ebp;
			sp[count].stackFrameSize = count > 0 ? sp[count].ret - sp[count - 1].ret : 0;
			count++;
		}
		else if (res == 2) // 6b
		{
b6:			sp[count].opcode = (uint*)(_ptr - 5);
			sp[count].opcodeSize = 6;
			sp[count].operand = (uint*)(_ptr - 3);
			sp[count].operandSize = 4;
			sp[count].ret = _ebp;
			sp[count].stackFrameSize = count > 0 ? sp[count].ret - sp[count - 1].ret : 0;
			count++;
		}
		else if (res == 4) // 2b
		{
b2:			sp[count].opcode = (uint*)(_ptr - 1);
			sp[count].opcodeSize = 2;
			sp[count].operand = 0;
			sp[count].operandSize = 0;
			sp[count].ret = _ebp;
			sp[count].stackFrameSize = count > 0 ? sp[count].ret - sp[count - 1].ret : 0;
			count++;
		}
		else if (res == 8) // 3b
		{
b3:		sp[count].opcode = (uint*)(_ptr - 2);
			sp[count].opcodeSize = 3;
			sp[count].operand = (uint*)_ptr;
			sp[count].operandSize = 1;
			sp[count].ret = _ebp;
			sp[count].stackFrameSize = count > 0 ? sp[count].ret - sp[count - 1].ret : 0;
			count++;
		}
		else if (res == 9) // 5b & 3b
		{
			int len = __trace(_ptr - 24, *_ebp);
			if (len == 5) goto b5; else goto b3;
		}
		else if (res == 10)// 6b & 3b
		{
			int len = __trace(_ptr - 24, *_ebp);
			if (len == 6) goto b6; else goto b3;
		}
		else if (res == 5) // 5b & 2b
		{
			int len = __trace(_ptr - 24, *_ebp);
			if (len == 5) goto b5; else goto b2;
		}
		else if (res == 6) // 6b & 2b
		{
			int len = __trace(_ptr - 24, *_ebp);
			if (len == 6) goto b6; else goto b2;
		}

		if (count == *size) break;
	}

	*size = count;
	return sp;
}

//        call,    __stack
int __trace(uchar* _ptr, uint adr)
{
	int size = 0;
	uchar *opcode = 0;

	while ((uint)_ptr < adr)
	{
		size = GetSizeOfCode(_ptr, opcode);
		_ptr+= size;
	}

	return size;
}

//    
int GetSizeOfCode(void *Code, uchar *pOpcode)
{
	Puchar cPtr;
	uchar Flags;
	bool PFX66, PFX67;
	bool SibPresent;
	uchar iMod, iRM, iReg;
	uchar OffsetSize, Add;
	uchar Opcode;

	uchar *OpcodeFlags, *OpcodeFlagsExt;

	OffsetSize = 0;
	PFX66 = FALSE;
	PFX67 = FALSE;
	cPtr = (Puchar)Code;

	__asm
	{
		mov Code, eax;
        Call Adr1;

//OpcodeFlags:
		_emit OP_MODRM;                      // 00
		_emit OP_MODRM;                      // 01
		_emit OP_MODRM;                      // 02
		_emit OP_MODRM;                      // 03
		_emit OP_DATA_I8;                    // 04
		_emit OP_DATA_PRE66_67;              // 05
		_emit OP_NONE;                       // 06
		_emit OP_NONE;                       // 07
		_emit OP_MODRM;                      // 08
		_emit OP_MODRM;                      // 09
		_emit OP_MODRM;                      // 0A
		_emit OP_MODRM;                      // 0B
		_emit OP_DATA_I8;                    // 0C
		_emit OP_DATA_PRE66_67;              // 0D
		_emit OP_NONE;                       // 0E
		_emit OP_NONE;                       // 0F
		_emit OP_MODRM;                      // 10
		_emit OP_MODRM;                      // 11
		_emit OP_MODRM;                      // 12
		_emit OP_MODRM;                      // 13
		_emit OP_DATA_I8;                    // 14
		_emit OP_DATA_PRE66_67;              // 15
		_emit OP_NONE;                       // 16
		_emit OP_NONE;                       // 17
		_emit OP_MODRM;                      // 18
		_emit OP_MODRM;                      // 19
		_emit OP_MODRM;                      // 1A
		_emit OP_MODRM;                      // 1B
		_emit OP_DATA_I8;                    // 1C
		_emit OP_DATA_PRE66_67;              // 1D
		_emit OP_NONE;                       // 1E
		_emit OP_NONE;                       // 1F
		_emit OP_MODRM;                      // 20
		_emit OP_MODRM;                      // 21
		_emit OP_MODRM;                      // 22
		_emit OP_MODRM;                      // 23
		_emit OP_DATA_I8;                    // 24
		_emit OP_DATA_PRE66_67;              // 25
		_emit OP_NONE;                       // 26
		_emit OP_NONE;                       // 27
		_emit OP_MODRM;                      // 28
		_emit OP_MODRM;                      // 29
		_emit OP_MODRM;                      // 2A
		_emit OP_MODRM;                      // 2B
		_emit OP_DATA_I8;                    // 2C
		_emit OP_DATA_PRE66_67;              // 2D
		_emit OP_NONE;                       // 2E
		_emit OP_NONE;                       // 2F
		_emit OP_MODRM;                      // 30
		_emit OP_MODRM;                      // 31
		_emit OP_MODRM;                      // 32
		_emit OP_MODRM;                      // 33
		_emit OP_DATA_I8;                    // 34
		_emit OP_DATA_PRE66_67;              // 35
		_emit OP_NONE;                       // 36
		_emit OP_NONE;                       // 37
		_emit OP_MODRM;                      // 38
		_emit OP_MODRM;                      // 39
		_emit OP_MODRM;                      // 3A
		_emit OP_MODRM;                      // 3B
		_emit OP_DATA_I8;                    // 3C
		_emit OP_DATA_PRE66_67;              // 3D
		_emit OP_NONE;                       // 3E
		_emit OP_NONE;                       // 3F
		_emit OP_NONE;                       // 40
		_emit OP_NONE;                       // 41
		_emit OP_NONE;                       // 42
		_emit OP_NONE;                       // 43
		_emit OP_NONE;                       // 44
		_emit OP_NONE;                       // 45
		_emit OP_NONE;                       // 46
		_emit OP_NONE;                       // 47
		_emit OP_NONE;                       // 48
		_emit OP_NONE;                       // 49
		_emit OP_NONE;                       // 4A
		_emit OP_NONE;                       // 4B
		_emit OP_NONE;                       // 4C
		_emit OP_NONE;                       // 4D
		_emit OP_NONE;                       // 4E
		_emit OP_NONE;                       // 4F
		_emit OP_NONE;                       // 50
		_emit OP_NONE;                       // 51
		_emit OP_NONE;                       // 52
		_emit OP_NONE;                       // 53
		_emit OP_NONE;                       // 54
		_emit OP_NONE;                       // 55
		_emit OP_NONE;                       // 56
		_emit OP_NONE;                       // 57
		_emit OP_NONE;                       // 58
		_emit OP_NONE;                       // 59
		_emit OP_NONE;                       // 5A
		_emit OP_NONE;                       // 5B
		_emit OP_NONE;                       // 5C
		_emit OP_NONE;                       // 5D
		_emit OP_NONE;                       // 5E
		_emit OP_NONE;                       // 5F
		_emit OP_NONE;                       // 60
		_emit OP_NONE;                       // 61
		_emit OP_MODRM;                      // 62
		_emit OP_MODRM;                      // 63
		_emit OP_NONE;                       // 64
		_emit OP_NONE;                       // 65
		_emit OP_NONE;                       // 66
		_emit OP_NONE;                       // 67
		_emit OP_DATA_PRE66_67;              // 68
		_emit OP_MODRM | OP_DATA_PRE66_67;   // 69
		_emit OP_DATA_I8;                    // 6A
		_emit OP_MODRM | OP_DATA_I8;         // 6B
		_emit OP_NONE;                       // 6C
		_emit OP_NONE;                       // 6D
		_emit OP_NONE;                       // 6E
		_emit OP_NONE;                       // 6F
		_emit OP_DATA_I8;                    // 70
		_emit OP_DATA_I8;                    // 71
		_emit OP_DATA_I8;                    // 72
		_emit OP_DATA_I8;                    // 73
		_emit OP_DATA_I8;                    // 74
		_emit OP_DATA_I8;                    // 75
		_emit OP_DATA_I8;                    // 76
		_emit OP_DATA_I8;                    // 77
		_emit OP_DATA_I8;                    // 78
		_emit OP_DATA_I8;                    // 79
		_emit OP_DATA_I8;                    // 7A
		_emit OP_DATA_I8;                    // 7B
		_emit OP_DATA_I8;                    // 7C
		_emit OP_DATA_I8;                    // 7D
		_emit OP_DATA_I8;                    // 7E
		_emit OP_DATA_I8;                    // 7F
		_emit OP_MODRM | OP_DATA_I8;         // 80
		_emit OP_MODRM | OP_DATA_PRE66_67;   // 81
		_emit OP_MODRM | OP_DATA_I8;         // 82
		_emit OP_MODRM | OP_DATA_I8;         // 83
		_emit OP_MODRM;                      // 84
		_emit OP_MODRM;                      // 85
		_emit OP_MODRM;                      // 86
		_emit OP_MODRM;                      // 87
		_emit OP_MODRM;                      // 88
		_emit OP_MODRM;                      // 89
		_emit OP_MODRM;                      // 8A
		_emit OP_MODRM;                      // 8B
		_emit OP_MODRM;                      // 8C
		_emit OP_MODRM;                      // 8D
		_emit OP_MODRM;                      // 8E
		_emit OP_MODRM;                      // 8F
		_emit OP_NONE;                       // 90
		_emit OP_NONE;                       // 91
		_emit OP_NONE;                       // 92
		_emit OP_NONE;                       // 93
		_emit OP_NONE;                       // 94
		_emit OP_NONE;                       // 95
		_emit OP_NONE;                       // 96
		_emit OP_NONE;                       // 97
		_emit OP_NONE;                       // 98
		_emit OP_NONE;                       // 99
		_emit OP_DATA_I16 | OP_DATA_PRE66_67;// 9A
		_emit OP_NONE;                       // 9B
		_emit OP_NONE;                       // 9C
		_emit OP_NONE;                       // 9D
		_emit OP_NONE;                       // 9E
		_emit OP_NONE;                       // 9F
		_emit OP_DATA_PRE66_67;              // A0
		_emit OP_DATA_PRE66_67;              // A1
		_emit OP_DATA_PRE66_67;              // A2
		_emit OP_DATA_PRE66_67;              // A3
		_emit OP_NONE;                       // A4
		_emit OP_NONE;                       // A5
		_emit OP_NONE;                       // A6
		_emit OP_NONE;                       // A7
		_emit OP_DATA_I8;                    // A8
		_emit OP_DATA_PRE66_67;              // A9
		_emit OP_NONE;                       // AA
		_emit OP_NONE;                       // AB
		_emit OP_NONE;                       // AC
		_emit OP_NONE;                       // AD
		_emit OP_NONE;                       // AE
		_emit OP_NONE;                       // AF
		_emit OP_DATA_I8;                    // B0
		_emit OP_DATA_I8;                    // B1
		_emit OP_DATA_I8;                    // B2
		_emit OP_DATA_I8;                    // B3
		_emit OP_DATA_I8;                    // B4
		_emit OP_DATA_I8;                    // B5
		_emit OP_DATA_I8;                    // B6
		_emit OP_DATA_I8;                    // B7
		_emit OP_DATA_PRE66_67;              // B8
		_emit OP_DATA_PRE66_67;              // B9
		_emit OP_DATA_PRE66_67;              // BA
		_emit OP_DATA_PRE66_67;              // BB
		_emit OP_DATA_PRE66_67;              // BC
		_emit OP_DATA_PRE66_67;              // BD
		_emit OP_DATA_PRE66_67;              // BE
		_emit OP_DATA_PRE66_67;              // BF
		_emit OP_MODRM | OP_DATA_I8;         // C0
		_emit OP_MODRM | OP_DATA_I8;         // C1
		_emit OP_DATA_I16;                   // C2
		_emit OP_NONE;                       // C3
		_emit OP_MODRM;                      // C4
		_emit OP_MODRM;                      // C5
		_emit OP_MODRM   | OP_DATA_I8;       // C6
		_emit OP_MODRM   | OP_DATA_PRE66_67; // C7
		_emit OP_DATA_I8 | OP_DATA_I16;      // C8
		_emit OP_NONE;                       // C9
		_emit OP_DATA_I16;                   // CA
		_emit OP_NONE;                       // CB
		_emit OP_NONE;                       // CC
		_emit OP_DATA_I8;                    // CD
		_emit OP_NONE;                       // CE
		_emit OP_NONE;                       // CF
		_emit OP_MODRM;                      // D0
		_emit OP_MODRM;                      // D1
		_emit OP_MODRM;                      // D2
		_emit OP_MODRM;                      // D3
		_emit OP_DATA_I8;                    // D4
		_emit OP_DATA_I8;                    // D5
		_emit OP_NONE;                       // D6
		_emit OP_NONE;                       // D7
		_emit OP_WORD;                       // D8
		_emit OP_WORD;                       // D9
		_emit OP_WORD;                       // DA
		_emit OP_WORD;                       // DB
		_emit OP_WORD;                       // DC
		_emit OP_WORD;                       // DD
		_emit OP_WORD;                       // DE
		_emit OP_WORD;                       // DF
		_emit OP_DATA_I8;                    // E0
		_emit OP_DATA_I8;                    // E1
		_emit OP_DATA_I8;                    // E2
		_emit OP_DATA_I8;                    // E3
		_emit OP_DATA_I8;                    // E4
		_emit OP_DATA_I8;                    // E5
		_emit OP_DATA_I8;                    // E6
		_emit OP_DATA_I8;                    // E7
		_emit OP_DATA_PRE66_67 | OP_REL32;   // E8
		_emit OP_DATA_PRE66_67 | OP_REL32;   // E9
		_emit OP_DATA_I16 | OP_DATA_PRE66_67;// EA
		_emit OP_DATA_I8;                    // EB
		_emit OP_NONE;                       // EC
		_emit OP_NONE;                       // ED
		_emit OP_NONE;                       // EE
		_emit OP_NONE;                       // EF
		_emit OP_NONE;                       // F0
		_emit OP_NONE;                       // F1
		_emit OP_NONE;                       // F2
		_emit OP_NONE;                       // F3
		_emit OP_NONE;                       // F4
		_emit OP_NONE;                       // F5
		_emit OP_MODRM;                      // F6
		_emit OP_MODRM;                      // F7
		_emit OP_NONE;                       // F8
		_emit OP_NONE;                       // F9
		_emit OP_NONE;                       // FA
		_emit OP_NONE;                       // FB
		_emit OP_NONE;                       // FC
		_emit OP_NONE;                       // FD
		_emit OP_MODRM;                      // FE
		_emit OP_MODRM | OP_REL32            // FF


//OpcodeFlagsExt:
		_emit OP_MODRM;                      // 00
		_emit OP_MODRM;                      // 01
		_emit OP_MODRM;                      // 02
		_emit OP_MODRM;                      // 03
		_emit OP_NONE;                       // 04
		_emit OP_NONE;                       // 05
		_emit OP_NONE;                       // 06
		_emit OP_NONE;                       // 07
		_emit OP_NONE;                       // 08
		_emit OP_NONE;                       // 09
		_emit OP_NONE;                       // 0A
		_emit OP_NONE;                       // 0B
		_emit OP_NONE;                       // 0C
		_emit OP_MODRM;                      // 0D
		_emit OP_NONE;                       // 0E
		_emit OP_MODRM | OP_DATA_I8;         // 0F
		_emit OP_MODRM;                      // 10
		_emit OP_MODRM;                      // 11
		_emit OP_MODRM;                      // 12
		_emit OP_MODRM;                      // 13
		_emit OP_MODRM;                      // 14
		_emit OP_MODRM;                      // 15
		_emit OP_MODRM;                      // 16
		_emit OP_MODRM;                      // 17
		_emit OP_MODRM;                      // 18
		_emit OP_NONE;                       // 19
		_emit OP_NONE;                       // 1A
		_emit OP_NONE;                       // 1B
		_emit OP_NONE;                       // 1C
		_emit OP_NONE;                       // 1D
		_emit OP_NONE;                       // 1E
		_emit OP_NONE;                       // 1F
		_emit OP_MODRM;                      // 20
		_emit OP_MODRM;                      // 21
		_emit OP_MODRM;                      // 22
		_emit OP_MODRM;                      // 23
		_emit OP_MODRM;                      // 24
		_emit OP_NONE;                       // 25
		_emit OP_MODRM;                      // 26
		_emit OP_NONE;                       // 27
		_emit OP_MODRM;                      // 28
		_emit OP_MODRM;                      // 29
		_emit OP_MODRM;                      // 2A
		_emit OP_MODRM;                      // 2B
		_emit OP_MODRM;                      // 2C
		_emit OP_MODRM;                      // 2D
		_emit OP_MODRM;                      // 2E
		_emit OP_MODRM;                      // 2F
		_emit OP_NONE;                       // 30
		_emit OP_NONE;                       // 31
		_emit OP_NONE;                       // 32
		_emit OP_NONE;                       // 33
		_emit OP_NONE;                       // 34
		_emit OP_NONE;                       // 35
		_emit OP_NONE;                       // 36
		_emit OP_NONE;                       // 37
		_emit OP_NONE;                       // 38
		_emit OP_NONE;                       // 39
		_emit OP_NONE;                       // 3A
		_emit OP_NONE;                       // 3B
		_emit OP_NONE;                       // 3C
		_emit OP_NONE;                       // 3D
		_emit OP_NONE;                       // 3E
		_emit OP_NONE;                       // 3F
		_emit OP_MODRM;                      // 40
		_emit OP_MODRM;                      // 41
		_emit OP_MODRM;                      // 42
		_emit OP_MODRM;                      // 43
		_emit OP_MODRM;                      // 44
		_emit OP_MODRM;                      // 45
		_emit OP_MODRM;                      // 46
		_emit OP_MODRM;                      // 47
		_emit OP_MODRM;                      // 48
		_emit OP_MODRM;                      // 49
		_emit OP_MODRM;                      // 4A
		_emit OP_MODRM;                      // 4B
		_emit OP_MODRM;                      // 4C
		_emit OP_MODRM;                      // 4D
		_emit OP_MODRM;                      // 4E
		_emit OP_MODRM;                      // 4F
		_emit OP_MODRM;                      // 50
		_emit OP_MODRM;                      // 51
		_emit OP_MODRM;                      // 52
		_emit OP_MODRM;                      // 53
		_emit OP_MODRM;                      // 54
		_emit OP_MODRM;                      // 55
		_emit OP_MODRM;                      // 56
		_emit OP_MODRM;                      // 57
		_emit OP_MODRM;                      // 58
		_emit OP_MODRM;                      // 59
		_emit OP_MODRM;                      // 5A
		_emit OP_MODRM;                      // 5B
		_emit OP_MODRM;                      // 5C
		_emit OP_MODRM;                      // 5D
		_emit OP_MODRM;                      // 5E
		_emit OP_MODRM;                      // 5F
		_emit OP_MODRM;                      // 60
		_emit OP_MODRM;                      // 61
		_emit OP_MODRM;                      // 62
		_emit OP_MODRM;                      // 63
		_emit OP_MODRM;                      // 64
		_emit OP_MODRM;                      // 65
		_emit OP_MODRM;                      // 66
		_emit OP_MODRM;                      // 67
		_emit OP_MODRM;                      // 68
		_emit OP_MODRM;                      // 69
		_emit OP_MODRM;                      // 6A
		_emit OP_MODRM;                      // 6B
		_emit OP_MODRM;                      // 6C
		_emit OP_MODRM;                      // 6D
		_emit OP_MODRM;                      // 6E
		_emit OP_MODRM;                      // 6F
		_emit OP_MODRM | OP_DATA_I8;         // 70
		_emit OP_MODRM | OP_DATA_I8;         // 71
		_emit OP_MODRM | OP_DATA_I8;         // 72
		_emit OP_MODRM | OP_DATA_I8;         // 73
		_emit OP_MODRM;                      // 74
		_emit OP_MODRM;                      // 75
		_emit OP_MODRM;                      // 76
		_emit OP_NONE;                       // 77
		_emit OP_NONE;                       // 78
		_emit OP_NONE;                       // 79
		_emit OP_NONE;                       // 7A
		_emit OP_NONE;                       // 7B
		_emit OP_MODRM;                      // 7C
		_emit OP_MODRM;                      // 7D
		_emit OP_MODRM;                      // 7E
		_emit OP_MODRM;                      // 7F
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 80
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 81
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 82
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 83
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 84
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 85
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 86
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 87
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 88
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 89
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 8A
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 8B
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 8C
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 8D
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 8E
		_emit OP_DATA_PRE66_67 | OP_REL32;   // 8F
		_emit OP_MODRM;                      // 90
		_emit OP_MODRM;                      // 91
		_emit OP_MODRM;                      // 92
		_emit OP_MODRM;                      // 93
		_emit OP_MODRM;                      // 94
		_emit OP_MODRM;                      // 95
		_emit OP_MODRM;                      // 96
		_emit OP_MODRM;                      // 97
		_emit OP_MODRM;                      // 98
		_emit OP_MODRM;                      // 99
		_emit OP_MODRM;                      // 9A
		_emit OP_MODRM;                      // 9B
		_emit OP_MODRM;                      // 9C
		_emit OP_MODRM;                      // 9D
		_emit OP_MODRM;                      // 9E
		_emit OP_MODRM;                      // 9F
		_emit OP_NONE;                       // A0
		_emit OP_NONE;                       // A1
		_emit OP_NONE;                       // A2
		_emit OP_MODRM;                      // A3
		_emit OP_MODRM | OP_DATA_I8;         // A4
		_emit OP_MODRM;                      // A5
		_emit OP_NONE;                       // A6
		_emit OP_NONE;                       // A7
		_emit OP_NONE;                       // A8
		_emit OP_NONE;                       // A9
		_emit OP_NONE;                       // AA
		_emit OP_MODRM;                      // AB
		_emit OP_MODRM | OP_DATA_I8;         // AC
		_emit OP_MODRM;                      // AD
		_emit OP_MODRM;                      // AE
		_emit OP_MODRM;                      // AF
		_emit OP_MODRM;                      // B0
		_emit OP_MODRM;                      // B1
		_emit OP_MODRM;                      // B2
		_emit OP_MODRM;                      // B3
		_emit OP_MODRM;                      // B4
		_emit OP_MODRM;                      // B5
		_emit OP_MODRM;                      // B6
		_emit OP_MODRM;                      // B7
		_emit OP_NONE;                       // B8
		_emit OP_NONE;                       // B9
		_emit OP_MODRM | OP_DATA_I8;         // BA
		_emit OP_MODRM;                      // BB
		_emit OP_MODRM;                      // BC
		_emit OP_MODRM;                      // BD
		_emit OP_MODRM;                      // BE
		_emit OP_MODRM;                      // BF
		_emit OP_MODRM;                      // C0
		_emit OP_MODRM;                      // C1
		_emit OP_MODRM | OP_DATA_I8;         // C2
		_emit OP_MODRM;                      // C3
		_emit OP_MODRM | OP_DATA_I8;         // C4
		_emit OP_MODRM | OP_DATA_I8;         // C5
		_emit OP_MODRM | OP_DATA_I8;         // C6 
		_emit OP_MODRM;                      // C7
		_emit OP_NONE;                       // C8
		_emit OP_NONE;                       // C9
		_emit OP_NONE;                       // CA
		_emit OP_NONE;                       // CB
		_emit OP_NONE;                       // CC
		_emit OP_NONE;                       // CD
		_emit OP_NONE;                       // CE
		_emit OP_NONE;                       // CF
		_emit OP_MODRM;                      // D0
		_emit OP_MODRM;                      // D1
		_emit OP_MODRM;                      // D2
		_emit OP_MODRM;                      // D3
		_emit OP_MODRM;                      // D4
		_emit OP_MODRM;                      // D5
		_emit OP_MODRM;                      // D6
		_emit OP_MODRM;                      // D7
		_emit OP_MODRM;                      // D8
		_emit OP_MODRM;                      // D9
		_emit OP_MODRM;                      // DA
		_emit OP_MODRM;                      // DB
		_emit OP_MODRM;                      // DC
		_emit OP_MODRM;                      // DD
		_emit OP_MODRM;                      // DE
		_emit OP_MODRM;                      // DF
		_emit OP_MODRM;                      // E0
		_emit OP_MODRM;                      // E1
		_emit OP_MODRM;                      // E2
		_emit OP_MODRM;                      // E3
		_emit OP_MODRM;                      // E4
		_emit OP_MODRM;                      // E5
		_emit OP_MODRM;                      // E6
		_emit OP_MODRM;                      // E7
		_emit OP_MODRM;                      // E8
		_emit OP_MODRM;                      // E9
		_emit OP_MODRM;                      // EA
		_emit OP_MODRM;                      // EB
		_emit OP_MODRM;                      // EC
		_emit OP_MODRM;                      // ED
		_emit OP_MODRM;                      // EE
		_emit OP_MODRM;                      // EF
		_emit OP_MODRM;                      // F0
		_emit OP_MODRM;                      // F1
		_emit OP_MODRM;                      // F2
		_emit OP_MODRM;                      // F3
		_emit OP_MODRM;                      // F4
		_emit OP_MODRM;                      // F5
		_emit OP_MODRM;                      // F6
		_emit OP_MODRM;                      // F7 
		_emit OP_MODRM;                      // F8
		_emit OP_MODRM;                      // F9
		_emit OP_MODRM;                      // FA
		_emit OP_MODRM;                      // FB
		_emit OP_MODRM;                      // FC
		_emit OP_MODRM;                      // FD
		_emit OP_MODRM;                      // FE
		_emit OP_NONE;                       // FF
	}

	__asm
	{
Adr1:	pop eax;
		mov OpcodeFlags, eax
        add eax, 100h
		mov OpcodeFlagsExt, eax
	}

	/*  */
	while ( (*cPtr == 0x2E) || (*cPtr == 0x3E) || (*cPtr == 0x36) ||
		    (*cPtr == 0x26) || (*cPtr == 0x64) || (*cPtr == 0x65) || 
			(*cPtr == 0xF0) || (*cPtr == 0xF2) || (*cPtr == 0xF3) ||
			(*cPtr == 0x66) || (*cPtr == 0x67) ) 
	{
		if (*cPtr == 0x66) PFX66 = TRUE;
		if (*cPtr == 0x67) PFX67 = TRUE;
		cPtr++;
		if (cPtr > (Puchar)Code + 16)
		{
			return 0;
		}
	}
	Opcode = *cPtr;
	pOpcode = cPtr;

	/*     */
	if (*cPtr == 0x0F)
	{
		cPtr++;
		Flags = OpcodeFlagsExt[*cPtr];
	} 
	else 
	{
		Flags = OpcodeFlags[Opcode];
		/*  A0 - A3  66 = 67*/
		if (Opcode >= 0xA0 && Opcode <= 0xA3) PFX66 = PFX67;
	}
	cPtr++;
	if (Flags & OP_WORD) cPtr++;	
	/* MOD r/m*/
	if (Flags & OP_MODRM)
	{
		iMod = *cPtr >> 6;
		iReg = (*cPtr & 0x38) >> 3;  
		iRM  = *cPtr &  7;
		cPtr++;
		/* F6  F7 - Immediate    iReg = 0*/
		if ((Opcode == 0xF6) && !iReg) Flags |= OP_DATA_I8;    
		if ((Opcode == 0xF7) && !iReg) Flags |= OP_DATA_PRE66_67; 
		/* SIB  Offset*/
		SibPresent = !PFX67 & (iRM == 4);
		switch (iMod)
		{
			case 0: 
			  if ( PFX67 && (iRM == 6)) OffsetSize = 2;
			  if (!PFX67 && (iRM == 5)) OffsetSize = 4; 
			 break;
			case 1: OffsetSize = 1;
			 break; 
			case 2: if (PFX67) OffsetSize = 2; else OffsetSize = 4;
			 break;
			case 3: SibPresent = FALSE;
		}
		if (SibPresent)
		{
			if (((*cPtr & 7) == 5) && ( (!iMod) || (iMod == 2) )) OffsetSize = 4;
			cPtr++;
		}
		cPtr = (Puchar)(uint)cPtr + OffsetSize;
	}
	/* IMM */
	if (Flags & OP_DATA_I8)  cPtr++;
	if (Flags & OP_DATA_I16) cPtr += 2;
	if (Flags & OP_DATA_I32) cPtr += 4;
	if (PFX66) Add = 2; else Add = 4;
	if (Flags & OP_DATA_PRE66_67) cPtr += Add;
	
	
	return (uint)cPtr - (uint)Code;
}

//    
void test()
{
	uchar *adr = 0;
	uchar *opcode = 0;
	int size = 0;

	__asm mov ebx, m1;
	__asm mov adr, ebx;

	//   
	adr += 7;

	while (*adr != 0xC3)
	{
		size = GetSizeOfCode(adr, opcode);
		char* str = new char[10];
		itoa(size, str, 10);
		printf(str);
		printf(", ");
		adr+= size;
	}

	return;
	
	__asm
	{
m1:
		mov		eax, 100h;
		je		m1;
		mov		dword ptr [ebp-4],eax;
		sub     byte ptr [esi],al;
		xor     eax, eax;
		cmp     dword ptr [ebp + 1], 0;


		_emit 0xE8;
		_emit 0x63;
		_emit 0xff;
		_emit 0x51;
		_emit 0x00;

		ret;
		ret;
		ret;
		ret;
		ret;
		ret;
		ret;
		ret;
	}

}
